<?php
/**
 * The template for displaying comments
 *
 * The area of the page that contains both current comments
 * and the comment form.
 *
 * @package WordPress
 * @subpackage Bouttique
 * @since bouttique 1.0
 */
/*
 * If the current post is protected by a password and
 * the visitor has not yet entered the password we will
 * return early without loading the comments.
 */
if ( post_password_required() ) return;

$comment_field  = '<p class="comment-form-comment"><label>'.__( 'Comment', 'digitalworld' ).' </label><textarea class="input-form" id="comment" name="comment" cols="45" rows="8" aria-required="true">' .
    '</textarea></p>';
$fields = array(
	'author' => '<div class="row"><div class="col-xs-12 col-sm-6"><p><label>'.__( 'Name', 'digitalworld' ).' <span class="required">*</span></label><input type="text" name="author" id="name" class="input-form" /></p></div>',
	'email'  => '<div class="col-xs-12 col-sm-6"><p><label>'.__( 'Email', 'digitalworld' ).' <span class="required">*</span></label><input type="text" name="email" id="email" class="input-form" /></p></div></div><!-- /.row -->',
);


$comment_form_args = array(
	'class_submit' =>'button',
	'comment_field'=> $comment_field,
	'fields'       => $fields
);
?>
<div id="comments" class="post-comments">
	<?php if ( have_comments() ) : ?>
        <h4 class="block-title"><?php echo get_comments_number();?> <?php esc_html_e('COMMENTS','digitalworld')?></h4>
		<?php digitalworld_comment_nav(); ?>
		<ol class="comments">
			<?php
				wp_list_comments( array(
					'style'       => 'ol',
					'short_ping'  => true,
					'avatar_size' => 68,
					'callback'	  => 'digitalworld_custom_comment'
				) );
			?>
		</ol><!-- .comment-list -->

		<?php digitalworld_comment_nav(); ?>
	<?php endif; // have_comments() ?>
	<?php
		// If comments are closed and there are comments, let's leave a little note, shall we?
		if ( ! comments_open() && get_comments_number() && post_type_supports( get_post_type(), 'comments' ) ) :
	?>
		<p class="no-comments"><?php esc_html_e( 'Comments are closed.', 'digitalworld' ); ?></p>
	<?php endif; ?>
	<?php comment_form($comment_form_args);?>
</div><!-- .comments-area -->