<?php
if ( !class_exists( 'Digitalworld_PluginLoad' ) ) {
	class Digitalworld_PluginLoad
	{
		public $plugins = array();
		public $config  = array();

		public function __construct()
		{
			$this->plugins();
			$this->config();
			if ( function_exists( 'tgmpa' ) ) {
				tgmpa( $this->plugins, $this->config );
			}
		}

		public function plugins()
		{
			$this->plugins = array(
				array(
					'name'               => 'Digitalworld Toolkit', // The plugin name
					'slug'               => 'digitalworld-toolkit', // The plugin slug (typically the folder name)
					'source'             => 'https://plugins.kutethemes.net/digitalworld-toolkit.zip', // The plugin source
					'required'           => true, // If false, the plugin is only 'recommended' instead of required
					'version'            => '1.0.5', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
					'force_activation'   => false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
					'force_deactivation' => false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
					'external_url'       => '', // If set, overrides default API URL and points to an external URL
					'image'              => 'https://plugins.kutethemes.net/images/digital-toolkit.jpg',
				),
				array(
					'name'               => 'Digitalworld Importer',
					'slug'               => 'digitalworld-importer',
					'source'             => 'https://plugins.kutethemes.net/digitalworld-importer.zip',
					'required'           => true,
					'version'            => '1.0.3',
					'force_activation'   => false,
					'force_deactivation' => false,
					'external_url'       => '',
					'image'              => 'https://plugins.kutethemes.net/images/digital-importer.jpg',
				),
				array(
					'name'               => 'Revolution Slider',
					'slug'               => 'revslider',
					'source'             => 'https://plugins.kutethemes.net/revslider.zip',
					'required'           => true,
					'version'            => '6.0.9',
					'force_activation'   => false,
					'force_deactivation' => false,
					'external_url'       => '',
					'image'              => 'https://plugins.kutethemes.net/images/slider-revolution.jpg',
				),
				array(
					'name'               => 'WPBakery Visual Composer',
					'slug'               => 'js_composer',
					'source'             => 'https://plugins.kutethemes.net/js_composer.zip',
					'required'           => true,
					'version'            => '',
					'force_activation'   => false,
					'force_deactivation' => false,
					'external_url'       => '',
					'image'              => 'https://plugins.kutethemes.net/images/visual-composer.png',
				),
				array(
					'name'     => 'Redux Framework',
					'slug'     => 'redux-framework',
					'required' => true,
					'image'    => 'https://plugins.kutethemes.net/images/images-import/redux.jpg',
				),
				array(
					'name'     => 'Meta Box',
					'slug'     => 'meta-box',
					'required' => true,
					'image'    => 'https://plugins.kutethemes.net/images/meta-box.jpg',
				),
				array(
					'name'     => 'WooCommerce',
					'slug'     => 'woocommerce',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/woocommerce.png',
				),
				array(
					'name'     => 'YITH WooCommerce Compare',
					'slug'     => 'yith-woocommerce-compare',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/compare.jpg',
				),
				array(
					'name'     => 'YITH WooCommerce Wishlist',
					'slug'     => 'yith-woocommerce-wishlist',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/wishlist.jpg',
				),
				array(
					'name'     => 'YITH WooCommerce Quick View',
					'slug'     => 'yith-woocommerce-quick-view',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/quickview.jpg',
				),
				array(
					'name'     => 'WOOF - WooCommerce Products Filter',
					'slug'     => 'woocommerce-products-filter',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/woof-woocommerce-products-filter.jpg',

				),
				array(
					'name'     => 'WooCommerce Currency Switcher',
					'slug'     => 'woocommerce-currency-switcher',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/woocommerce-currency-switcher.jpg',
				),
				array(
					'name'     => 'Contact Form 7',
					'slug'     => 'contact-form-7',
					'required' => false,
					'image'    => 'https://plugins.kutethemes.net/images/contactform7.png',
				),
			);
		}

		public function config()
		{
			$this->config = array(
				'id'           => 'digitalworld', // Unique ID for hashing notices for multiple instances of TGMPA.
				'default_path' => '',                      // Default absolute path to bundled plugins.
				'menu'         => 'digitalworld-install-plugins', // Menu slug.
				'parent_slug'  => 'themes.php',            // Parent menu slug.
				'capability'   => 'edit_theme_options',    // Capability needed to view plugin install page, should be a capability associated with the parent menu used.
				'has_notices'  => true,                    // Show admin notices or not.
				'dismissable'  => true,                    // If false, a user cannot dismiss the nag message.
				'dismiss_msg'  => '',                      // If 'dismissable' is false, this message will be output at top of nag.
				'is_automatic' => true,                   // Automatically activate plugins after installation or not.
				'message'      => '',                      // Message to output right before the plugins table.
			);
		}
	}
}
if ( !function_exists( 'Digitalworld_PluginLoad' ) ) {
	function Digitalworld_PluginLoad()
	{
		new  Digitalworld_PluginLoad();
	}
}
add_action( 'tgmpa_register', 'Digitalworld_PluginLoad' );