<?php get_header();?>
<?php
/*Default  page layout*/
$digitalworld_page_extra_class = digitalworld_get_post_meta(get_the_ID(),'digitalworld_page_extra_class','');
$digitalworld_page_layout = digitalworld_get_post_meta(get_the_ID(),'digitalworld_page_layout','left');
/*Main container class*/
$digitalworld_main_container_class = array();
$digitalworld_main_container_class[] = $digitalworld_page_extra_class;
$digitalworld_main_container_class[] = 'main-container';
if( $digitalworld_page_layout == 'full'){
    $digitalworld_main_container_class[] = 'no-sidebar';
}else{
    $digitalworld_main_container_class[] = $digitalworld_page_layout.'-slidebar';
}
$digitalworld_main_content_class = array();
$digitalworld_main_content_class[] = 'main-content';
if( $digitalworld_page_layout == 'full' ){
    $digitalworld_main_content_class[] ='col-sm-12';
}else{
    $digitalworld_main_content_class[] = 'col-md-9 col-sm-8';
}
$digitalworld_slidebar_class = array();
$digitalworld_slidebar_class[] = 'sidebar';
if( $digitalworld_page_layout != 'full'){
    $digitalworld_slidebar_class[] = 'col-md-3 col-sm-4';
}
?>

<main class="site-main <?php echo esc_attr( implode(' ', $digitalworld_main_container_class) );?>">
    <div class="container">
        <?php get_template_part('template_parts/part','breadcrumb');?>
        <div class="row">
            <div class="<?php echo esc_attr( implode(' ', $digitalworld_main_content_class) );?>">
                <?php
                if( have_posts()){
                    while( have_posts()){
                        the_post();
                        ?>
                        <div class="page-main-content">
                            <?php
                            the_content();
                            wp_link_pages( array(
                                'before'      => '<div class="page-links"><span class="page-links-title">' . esc_html__( 'Pages:', 'digitalworld' ) . '</span>',
                                'after'       => '</div>',
                                'link_before' => '<span>',
                                'link_after'  => '</span>',
                                'pagelink'    => '<span class="screen-reader-text">' . esc_html__( 'Page', 'digitalworld' ) . ' </span>%',
                                'separator'   => '<span class="screen-reader-text">, </span>',
                            ) );
                            ?>
                        </div>
                        <?php
                        // If comments are open or we have at least one comment, load up the comment template.
                        if ( comments_open() || get_comments_number() ) :
                            comments_template();
                        endif;
                        ?>
                        <?php
                    }
                }
                ?>
            </div>
            <?php if( $digitalworld_page_layout != "full" ):?>
                <div class="<?php echo esc_attr( implode(' ', $digitalworld_slidebar_class) );?>">
                    <?php get_sidebar('page');?>
                </div>
            <?php endif;?>
        </div>
    </div>
</main>
<?php get_footer();