<?php
$digitalworld_blog_placehold  = digitalworld_option('digitalworld_blog_placehold','no');
?>
<div class="post-detail">
    <div <?php post_class('post-item');?>>
        <?php if( has_post_thumbnail() || $digitalworld_blog_placehold =='yes' ): ?>
            <div class="post-thumb">
                <?php the_post_thumbnail('full');?>
            </div>
        <?php endif;?>
        <div class="post-item-info">
            <h3 class="post-name">
                <a href="<?php the_permalink();?>"><?php the_title();?></a>
            </h3>
            <div class="post-metas">
                <?php
                if ( is_sticky() && is_home() && ! is_paged() ) {
                    printf( '<span class="sticky-post">%s</span>', esc_html__( 'Sticky', 'digitalworld' ) );
                }
                ?>
                <span class="author"><?php esc_html_e('Posted by:','digitalworld');?> <?php the_author();?></span>
                <span class="time">
                        <span class="day"><?php echo get_the_date('j');?></span>
                    <?php echo get_the_date('M, j');?>
                    </span>
            </div>
            <div class="post-content"><?php the_content(); ?></div>
        </div>
        <?php
        wp_link_pages( array(
            'before'      => '<div class="page-links">',
            'after'       => '</div>',
            'link_before' => '<span>',
            'link_after'  => '</span>',
            'pagelink'    => '%',
            'separator'   => '',
        ) );
        ?>
    </div>

    <div class="post-footer">
        <?php if( has_tag() ):?>
        <div class="tags">
            <label><?php esc_html_e('Tags:','digitalworld');?></label>
            <?php the_tags( '', ', ' ); ?>
        </div>
        <?php endif;?>
        <?php get_template_part('templates/blogs/blog','bio');?>
    </div>
</div>